<template>
    <div>
        <form id="create-post-container" class="d-flex justify-content-around flex-column">
            <div id="closed-editor-container" class="d-flex justify-content-between">
                <p class="text-light mb-0 ml-2">Créer un nouveau post</p>
                <button @click.prevent='openEditor' id="open-editor" class="fas fa-sort-down" aria-label="Ouvrir création de post"></button>
            </div>
            <div v-if='open' class="d-flex justify-content-around flex-column mt-2">
                <input type="text" v-model="form.title" placeholder="Titre" aria-label="Titre du post">
                <textarea v-model="form.content" placeholder="Message.." class="mt-2 little-font" rows="5" cols="23" aria-label="Texte du post"></textarea>
                <div class="container-post ml-5">
                    <label for="file-upload" class="custom-file-upload text-left mt-2 px-2">Ajouter une image</label>
                    <input id="file-upload" type="file" v-on:change="onFileSelected" aria-label="Ajouter une image">
                    
                </div>
                <div v-if="selectedFile !== ''" class="text-light little-font cuted-text">{{ selectedFile }}</div>
                <button id="add" @click.prevent="createNewPost()" type="button" aria-label="Enregistrer un nouveau post">Enregister le post <i class="fas fa-save"></i></button>
            </div>
        </form>
    </div>
</template>

<script>
    import axios from 'axios'
    export default {
        data() {
            return {
                name: 'CreatePost',
                form: {
                    title: null,
                    content: null,
                    image: null,
                    UserId: null
                },
                selectedFile: '',
                open: false
            }
        },
        methods: {
            checkUserId(){
                const jwt = require('jsonwebtoken')
                const token = JSON.parse(localStorage.getItem('token'))
                const decodedToken = jwt.verify(token, 'RANDOM_TOKEN_SECRET');
                const userId = decodedToken.userId;
                this.form.UserId = userId
            },
            openEditor() {
                this.open=!this.open
            },
            onFileSelected(event) {
                this.form.image = event.target.files[0]
                this.selectedFile = event.target.files[0].name
            },
            createNewPost: 
            function () {
                this.checkUserId()
                const url = 'http://localhost:3000/api/posts/new'
                const fd = new FormData()
                fd.append('title', this.form.title)
                fd.append('content', this.form.content)
                if (this.selectedFile !== '') {
                    fd.append('image', this.form.image, this.selectedFile)
                }else{
                    fd.append('image','')
                }
                fd.append('UserId', this.form.UserId)
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                axios.post(url, fd, config)
                .then(function(){
                    location.reload()
                })
                .catch(error => error.message)
            }
        }
    }
</script>

<style scoped src="./CreatePost.css">

</style>